#include "GL_Switch.h"
#include "X3D_Switch.h"

namespace X3DTK {
namespace GL {

Switch::Switch()
: X3DGroupingNode()
{
  define(Recorder<Switch>::getTypeName("Switch", "Grouping"));
  
  define(Recorder<Switch, SFInt32>::getAttribute("whichChoice", &Switch::_whichChoice, -1));
}

Switch::~Switch()
{
}

void Switch::setWhichChoice(const SFInt32 &whichChoice)
{
  _whichChoice = whichChoice;
}

void Switch::update()
{
  if (x3dReference == 0)
    return;
  
  X3D::Switch *S = static_cast<X3D::Switch *>(x3dReference);  
  
  _whichChoice = S->getWhichChoice();
}

}
}
