#include "X3D_Scene.h"
#include "X3D_X3DChildNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Scene::Scene()
: X3DGroupingNode(), X3DBoundedObject()
{
  define(Recorder<Scene>::getTypeName("Scene", "Core"));
}

Scene::~Scene()
{
  removeRoutes();
}

void Scene::setFileName(const SFString &file)
{
  _fileName = file;
}

void Scene::setProcessHistory(const ProcessHistory &history)
{
  _history = history;
}

void Scene::setRoutes(const MFRoute &routes)
{
  _routes = routes;
}

void Scene::removeRoutes()
{
  for (MFRoute::const_iterator it = _routes.begin(); it != _routes.end(); ++it)
    X3DRoute::remove(*it);

  _routes.clear();
}

}
}
