#include "X3D_SharedCoordComputerStateVariables.h"
#include "X3D_Transform.h"
#include "X3D_IndexedFaceSet.h"
#include "X3D_Scene.h"
#include "X3D_Coordinate.h"

#include <algorithm>

using namespace std;

namespace X3DTK {
namespace X3D {

SharedCoordComputerStateVariables::SharedCoordComputerStateVariables()
{
}

SharedCoordComputerStateVariables::~SharedCoordComputerStateVariables()
{
}

void SharedCoordComputerStateVariables::finish()
{
  _coordinateList.clear();
}

map<IndexedFaceSet *, std::pair<bool, list<SFNode> > > &SharedCoordComputerStateVariables::find(const list<IndexedFaceSet *> &ifslist)
{
  _ifsmap.clear();
  
  for (list<IndexedFaceSet *>::const_iterator it = ifslist.begin(); it != ifslist.end(); ++it)
    pfind(*it, *it);
  
  return _ifsmap;  
}

void SharedCoordComputerStateVariables::pfind(IndexedFaceSet *I, SFNode N)
{
  const MFNode &parentList = N->getParentList();
  
  for (MFNode::const_iterator it = parentList.begin(); it != parentList.end(); ++it)
  {
    if ((dynamic_cast<Transform *>(*it) != 0) || (dynamic_cast<Scene *>(*it)))
    {
      _ifsmap[I].first = false;
      _ifsmap[I].second.push_back(*it);
    }  
    else
      pfind(I, *it);
  }
}

void SharedCoordComputerStateVariables::addNode(Coordinate *C)
{
  _coordinateList.push_back(C);
}

bool SharedCoordComputerStateVariables::getNode(Coordinate *C) const
{
  list<SFNode>::const_iterator it = std::find(_coordinateList.begin(), _coordinateList.end(), C);
  return (it != _coordinateList.end());
}

}
}
