#include "MemReleaser.h"
#include "DFSGraphTraversal.h"
#include "MemReleaserAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MemReleaser::MemReleaser()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new MemReleaserAbstractVisitor());
}

MemReleaser::~MemReleaser()
{
  Singleton<MemReleaserStateVariables>::removeInstance();
}

void MemReleaser::release(SFNode N, bool verbose)
{
  Singleton<MemReleaserStateVariables>::getInstance()->setVerbose(verbose);
  Singleton<MemReleaserStateVariables>::getInstance()->init();
  traverse(N);
  Singleton<MemReleaserStateVariables>::getInstance()->finish();
}

void MemReleaser::init()
{
  Singleton<MemReleaserStateVariables>::getInstance()->init();
}

void MemReleaser::finish()
{
  Singleton<MemReleaserStateVariables>::getInstance()->finish();
}

}
