#include "X3DComponent.h"
#include "X3DAbstractNode.h"

#include <algorithm>
#include <iostream>

using namespace std;
using namespace X3DTK;

X3DComponent::X3DComponent()
: _actorNumber(0)
{
}

X3DComponent::~X3DComponent()
{
  //cout << "destr X3DComponent " << component->getName() << " = " << (void *)this << endl;
  SFComponent::removeOneReference(component);
}

void X3DComponent::addOneActor()
{
  ++_actorNumber;  
}

void X3DComponent::removeOneActor()
{
  --_actorNumber;  
}

void X3DComponent::defineComponentName(const SFString &name, const SFString &sceneGraph)
{
  //cout << "new X3DComponent " << name << " = " << (void *)this << endl;
  component = SFComponent::getComponent(sceneGraph, name);
  
  if (component == 0)
    component = new SFComponent(name, sceneGraph);
  
  component->addOneReference();  
}
